# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .include_criteria_merchant_account_number_list import (
    IncludeCriteriaMerchantAccountNumberList,
)
from .include_criteria_search_filter import IncludeCriteriaSearchFilter
from .include_criteria_service_offering_list import IncludeCriteriaServiceOfferingList


@JsonMap(
    {
        "merchant_account_number_list": "MerchantAccountNumberList",
        "search_filter": "SearchFilter",
        "service_offering_list": "ServiceOfferingList",
    }
)
class AccessPointSearchIncludeCriteria(BaseModel):
    """This contains elements to refine (include) UPS Access point address or geocode Search.

    :param merchant_account_number_list: This contains the list of Merchant Account numbers to be used for finding private network access points., defaults to None
    :type merchant_account_number_list: IncludeCriteriaMerchantAccountNumberList, optional
    :param search_filter: Container to hold one or more search criteria for UPS Access Points that allow DCR, Shipping and ClickAndCollect access. Only applicable when the UPS access point candidate list is obtained in search by address or geocode search., defaults to None
    :type search_filter: IncludeCriteriaSearchFilter, optional
    :param service_offering_list: Container to hold end point service offering List for UPS Access point. Applicable only when a UPS Access Point candidate list is obtained in search by address or geocode search., defaults to None
    :type service_offering_list: IncludeCriteriaServiceOfferingList, optional
    """

    def __init__(
        self,
        merchant_account_number_list: IncludeCriteriaMerchantAccountNumberList = None,
        search_filter: IncludeCriteriaSearchFilter = None,
        service_offering_list: IncludeCriteriaServiceOfferingList = None,
    ):
        if merchant_account_number_list is not None:
            self.merchant_account_number_list = self._define_object(
                merchant_account_number_list, IncludeCriteriaMerchantAccountNumberList
            )
        if search_filter is not None:
            self.search_filter = self._define_object(
                search_filter, IncludeCriteriaSearchFilter
            )
        if service_offering_list is not None:
            self.service_offering_list = self._define_object(
                service_offering_list, IncludeCriteriaServiceOfferingList
            )
