# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .distance_unit_of_measurement import DistanceUnitOfMeasurement


@JsonMap({"value": "Value", "unit_of_measurement": "UnitOfMeasurement"})
class DropLocationDistance(BaseModel):
    """Container for the straight line distance from the origin to the UPS location.

    :param value: The straight line distance from the origin to the UPS location. Distance value may include one decimal and followed by one decimal place.
    :type value: str
    :param unit_of_measurement: The unit of measurement the user will see for the distance is based on the user input provided in the search request.
    :type unit_of_measurement: DistanceUnitOfMeasurement
    """

    def __init__(self, value: str, unit_of_measurement: DistanceUnitOfMeasurement):
        self.value = value
        self.unit_of_measurement = self._define_object(
            unit_of_measurement, DistanceUnitOfMeasurement
        )
