# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"phrase_id": "PhraseID", "text_to_speech_indicator": "TextToSpeechIndicator"})
class DropLocationIvr(BaseModel):
    """Integrated Voice Response information.
    ONLY FOR IVR.

    :param phrase_id: Contains the name of the IVR file that relates to this drop location. The file is an audio recording of information related to the location. ONLY FOR IVR.
    :type phrase_id: str
    :param text_to_speech_indicator: Indicates to the response recipient that the information has changed, and a new audio file should be produced.  ONLY FOR IVR., defaults to None
    :type text_to_speech_indicator: str, optional
    """

    def __init__(self, phrase_id: str, text_to_speech_indicator: str = None):
        self.phrase_id = phrase_id
        if text_to_speech_indicator is not None:
            self.text_to_speech_indicator = text_to_speech_indicator
