# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"pick_up_time": "PickUpTime", "no_pick_up_indicator": "NoPickUpIndicator"})
class PickUpPickUpDetails(BaseModel):
    """PickUpDetails container contains either pickup time or NoPickupIndicator. Either PickUpTime or NoPickupIndicator

    :param pick_up_time: Pickup time of transportation service for a location in military format (HHMM) e.g. 0930, 1700, 1845 etc. with exception for midnight. For midnight the time will be returned as 0., defaults to None
    :type pick_up_time: str, optional
    :param no_pick_up_indicator: Presence or Absence Indicator. If present, Indicates that there is no pickup time for the day.
    :type no_pick_up_indicator: str
    """

    def __init__(self, no_pick_up_indicator: str, pick_up_time: str = None):
        if pick_up_time is not None:
            self.pick_up_time = pick_up_time
        self.no_pick_up_indicator = no_pick_up_indicator
