# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .drop_location_ivr import DropLocationIvr
from .drop_location_geocode import DropLocationGeocode
from .drop_location_address_key_format import DropLocationAddressKeyFormat
from .drop_location_location_attribute import DropLocationLocationAttribute
from .drop_location_distance import DropLocationDistance
from .drop_location_special_instructions import DropLocationSpecialInstructions
from .drop_location_additional_comments import DropLocationAdditionalComments
from .drop_location_operating_hours import DropLocationOperatingHours
from .drop_location_localized_instruction import DropLocationLocalizedInstruction
from .drop_location_promotion_information import DropLocationPromotionInformation
from .drop_location_sort_code import DropLocationSortCode
from .drop_location_service_offering_list import DropLocationServiceOfferingList
from .drop_location_access_point_information import DropLocationAccessPointInformation
from .drop_location_location_image import DropLocationLocationImage


@JsonMap(
    {
        "location_id": "LocationID",
        "origin_or_destination": "OriginOrDestination",
        "ivr": "IVR",
        "geocode": "Geocode",
        "address_key_format": "AddressKeyFormat",
        "phone_number": "PhoneNumber",
        "fax_number": "FaxNumber",
        "e_mail_address": "EMailAddress",
        "location_attribute": "LocationAttribute",
        "distance": "Distance",
        "special_instructions": "SpecialInstructions",
        "latest_ground_drop_off_time": "LatestGroundDropOffTime",
        "latest_air_drop_off_time": "LatestAirDropOffTime",
        "additional_charge_indicator": "AdditionalChargeIndicator",
        "standard_hours_of_operation": "StandardHoursOfOperation",
        "non_standard_hours_of_operation": "NonStandardHoursOfOperation",
        "will_call_hours_of_operation": "WillCallHoursOfOperation",
        "number": "Number",
        "home_page_url": "HomePageURL",
        "comments": "Comments",
        "additional_comments": "AdditionalComments",
        "disclaimer": "Disclaimer",
        "slic": "SLIC",
        "timezone": "Timezone",
        "facility_type": "FacilityType",
        "operating_hours": "OperatingHours",
        "localized_instruction": "LocalizedInstruction",
        "promotion_information": "PromotionInformation",
        "sort_code": "SortCode",
        "service_offering_list": "ServiceOfferingList",
        "display_phone_number_indicator": "DisplayPhoneNumberIndicator",
        "access_point_information": "AccessPointInformation",
        "location_image": "LocationImage",
        "location_new_indicator": "LocationNewIndicator",
        "promotional_link_url": "PromotionalLinkURL",
        "featured_rank": "FeaturedRank",
        "will_call_location_indicator": "WillCallLocationIndicator",
    }
)
class SearchResultsDropLocation(BaseModel):
    """SearchResultsDropLocation

    :param location_id: The location ID that corresponds to the UPS location. Do not expose the Location ID.
    :type location_id: str
    :param origin_or_destination: OriginOrDestination will returned for FreightWillCallRequestType 1 Postal based and 3 City and/or State based search.  OriginOrDestination will be 01 for origin facilities and 02 for Destination facilities
    :type origin_or_destination: str
    :param ivr: Integrated Voice Response information.  ONLY FOR IVR.
    :type ivr: DropLocationIvr
    :param geocode: Geocode is the latitude and longitude of the location address. The Geocode for the location address will be returned when Location is requested in the Request Option.
    :type geocode: DropLocationGeocode
    :param address_key_format: Contains all of the basic information about a location, Consignee Name, Building Name, Address Lines, City, State/Province, Postal Code and Country or Terriotry Code.
    :type address_key_format: DropLocationAddressKeyFormat
    :param phone_number: The UPS locations Phone number. A phone number of the location will be returned. 10 digits allowed for US, otherwise 1..15 digits allowed. The phone number will be returned as a string. **NOTE:** For versions >= v2, this element will always be returned as an array. For requests using version = v1, this element will be returned as an array if there is more than one object and a single object if there is only 1.
    :type phone_number: List[str]
    :param fax_number: The UPS location's Fax number. A fax number of the location will be returned when available.  10 digits allowed for US, otherwise 1..15 digits allowed. The fax number will be returned as string., defaults to None
    :type fax_number: str, optional
    :param e_mail_address: Email address of the UPS location. Returned when available., defaults to None
    :type e_mail_address: str, optional
    :param location_attribute: OptionType is a container that indicates the type of the location attribute. There are 4 types of attributes. They are: Location, Retail Location, Additional Services and Program Type. **NOTE:** For versions >= v2, this element will always be returned as an array. For requests using version = v1, this element will be returned as an array if there is more than one object and a single object if there is only 1.
    :type location_attribute: List[DropLocationLocationAttribute]
    :param distance: Container for the straight line distance from the origin to the UPS location.
    :type distance: DropLocationDistance
    :param special_instructions: Walking directions. **NOTE:** For versions >= v2, this element will always be returned as an array. For requests using version = v1, this element will be returned as an array if there is more than one object and a single object if there is only 1. , defaults to None
    :type special_instructions: List[DropLocationSpecialInstructions], optional
    :param latest_ground_drop_off_time: The latest ground time the users can Drop-off the package at the location to be picked up. The time information is based on the time at the UPS location. When a user specifies a Drop-off Time and Ground as the Service Type, the locations that have latest Drop-off times equal to or later than the specified Drop-off time and service type are returned. **NOTE:** For versions >= v2, this element will always be returned as an array. For requests using version = v1, this element will be returned as an array if there is more than one object and a single object if there is only 1. , defaults to None
    :type latest_ground_drop_off_time: List[str], optional
    :param latest_air_drop_off_time: The latest airtime the users can Drop-off the package at the location to be picked up. The time information is based on the time at the UPS location. When a user specifies a Drop-off Time and Air as the Service Type, the locations that have latest Drop-off times equal to or later than the specified Drop-off time and service type are returned. **NOTE:** For versions >= v2, this element will always be returned as an array. For requests using version = v1, this element will be returned as an array if there is more than one object and a single object if there is only 1. , defaults to None
    :type latest_air_drop_off_time: List[str], optional
    :param additional_charge_indicator: Presence or Absence Indicator. If present, Indicates if the UPS location would have an additional charge. ASO locations will require an additional charge., defaults to None
    :type additional_charge_indicator: str, optional
    :param standard_hours_of_operation: The standard hours of operation of the drop location will be returned when available. The location's time may differ because of holidays., defaults to None
    :type standard_hours_of_operation: str, optional
    :param non_standard_hours_of_operation: The non-standard hours of operation of the drop location. The location's time may differ because of holidays, weekends, or other factors that are beyond the locations control. Seven days preceding a given holiday the Non Standard Hours Of Operation will be returned along with the standard hours of operation if available., defaults to None
    :type non_standard_hours_of_operation: str, optional
    :param will_call_hours_of_operation: The will call hours of operation of the drop location will be returned when available. The location's time may differ because of holidays., defaults to None
    :type will_call_hours_of_operation: str, optional
    :param number: The center number of the drop location if it is The UPS store., defaults to None
    :type number: str, optional
    :param home_page_url: The home page URL of the drop location if it is The UPS store., defaults to None
    :type home_page_url: str, optional
    :param comments: Comments returned about the location. Text will be displayed in English or the locale given in the request. If Country Code is FR, and locale passed in the request is "fr_FR" then text will be displayed in French language, else comment will be displayed in English language., defaults to None
    :type comments: str, optional
    :param additional_comments: Container for Additional Comments about Location.Text will be displayed in the Locale requested., defaults to None
    :type additional_comments: DropLocationAdditionalComments, optional
    :param disclaimer: Textual disclaimer about the drop location. **NOTE:** For versions >= v2, this element will always be returned as an array. For requests using version = v1, this element will be returned as an array if there is more than one object and a single object if there is only 1. , defaults to None
    :type disclaimer: List[str], optional
    :param slic: SLIC., defaults to None
    :type slic: str, optional
    :param timezone: TimeZone.
    :type timezone: str
    :param facility_type: PKG/FRT., defaults to None
    :type facility_type: str, optional
    :param operating_hours: Operating Hours., defaults to None
    :type operating_hours: DropLocationOperatingHours, optional
    :param localized_instruction: LocalizedInstruction container. Applicable for SearchOptionCode 01, 02, 03. **NOTE:** For versions >= v2, this element will always be returned as an array. For requests using version = v1, this element will be returned as an array if there is more than one object and a single object if there is only 1. , defaults to None
    :type localized_instruction: List[DropLocationLocalizedInstruction], optional
    :param promotion_information: Container to hold any promotion text for the location. Text will be displayed in English or the locale given in the request. **NOTE:** For versions >= v2, this element will always be returned as an array. For requests using version = v1, this element will be returned as an array if there is more than one object and a single object if there is only 1. , defaults to None
    :type promotion_information: List[DropLocationPromotionInformation], optional
    :param sort_code: This container is only for Freight Will call Search., defaults to None
    :type sort_code: DropLocationSortCode, optional
    :param service_offering_list: Container to hold the list of service offerings at the end point., defaults to None
    :type service_offering_list: DropLocationServiceOfferingList, optional
    :param display_phone_number_indicator: Valid Values:  0-Do not display phone number 1-Display phone number.  This indicator will be returned only for the contact type Telephone number. This indicator is used by the clients to determine whether to display the telephone number to the end user., defaults to None
    :type display_phone_number_indicator: str, optional
    :param access_point_information: Container for UPS Access Point specific parameters., defaults to None
    :type access_point_information: DropLocationAccessPointInformation, optional
    :param location_image: Location Image container., defaults to None
    :type location_image: DropLocationLocationImage, optional
    :param location_new_indicator: Indicator for new location., defaults to None
    :type location_new_indicator: str, optional
    :param promotional_link_url: Promotional link URL for specific location., defaults to None
    :type promotional_link_url: str, optional
    :param featured_rank: Feature Ranking values: Null or blank - Location is not featured.  1 - Featured Location ranked number 1. 2 - Featured Location ranked number 2., defaults to None
    :type featured_rank: str, optional
    :param will_call_location_indicator: Will Call Location Indicator values: - Y – Signifies a Will Call location that serves the customers address. - N - Signifies it is not a Will Call location. Will Call locations are only returned with a \"Y\" indicator if the request included EnhancedSearchOption code 10. , defaults to None
    :type will_call_location_indicator: str, optional
    """

    def __init__(
        self,
        location_id: str,
        origin_or_destination: str,
        ivr: DropLocationIvr,
        geocode: DropLocationGeocode,
        address_key_format: DropLocationAddressKeyFormat,
        phone_number: List[str],
        location_attribute: List[DropLocationLocationAttribute],
        distance: DropLocationDistance,
        timezone: str,
        fax_number: str = None,
        e_mail_address: str = None,
        special_instructions: List[DropLocationSpecialInstructions] = None,
        latest_ground_drop_off_time: List[str] = None,
        latest_air_drop_off_time: List[str] = None,
        additional_charge_indicator: str = None,
        standard_hours_of_operation: str = None,
        non_standard_hours_of_operation: str = None,
        will_call_hours_of_operation: str = None,
        number: str = None,
        home_page_url: str = None,
        comments: str = None,
        additional_comments: DropLocationAdditionalComments = None,
        disclaimer: List[str] = None,
        slic: str = None,
        facility_type: str = None,
        operating_hours: DropLocationOperatingHours = None,
        localized_instruction: List[DropLocationLocalizedInstruction] = None,
        promotion_information: List[DropLocationPromotionInformation] = None,
        sort_code: DropLocationSortCode = None,
        service_offering_list: DropLocationServiceOfferingList = None,
        display_phone_number_indicator: str = None,
        access_point_information: DropLocationAccessPointInformation = None,
        location_image: DropLocationLocationImage = None,
        location_new_indicator: str = None,
        promotional_link_url: str = None,
        featured_rank: str = None,
        will_call_location_indicator: str = None,
    ):
        self.location_id = location_id
        self.origin_or_destination = origin_or_destination
        self.ivr = self._define_object(ivr, DropLocationIvr)
        self.geocode = self._define_object(geocode, DropLocationGeocode)
        self.address_key_format = self._define_object(
            address_key_format, DropLocationAddressKeyFormat
        )
        self.phone_number = phone_number
        if fax_number is not None:
            self.fax_number = fax_number
        if e_mail_address is not None:
            self.e_mail_address = e_mail_address
        self.location_attribute = self._define_list(
            location_attribute, DropLocationLocationAttribute
        )
        self.distance = self._define_object(distance, DropLocationDistance)
        if special_instructions is not None:
            self.special_instructions = self._define_list(
                special_instructions, DropLocationSpecialInstructions
            )
        if latest_ground_drop_off_time is not None:
            self.latest_ground_drop_off_time = latest_ground_drop_off_time
        if latest_air_drop_off_time is not None:
            self.latest_air_drop_off_time = latest_air_drop_off_time
        if additional_charge_indicator is not None:
            self.additional_charge_indicator = additional_charge_indicator
        if standard_hours_of_operation is not None:
            self.standard_hours_of_operation = standard_hours_of_operation
        if non_standard_hours_of_operation is not None:
            self.non_standard_hours_of_operation = non_standard_hours_of_operation
        if will_call_hours_of_operation is not None:
            self.will_call_hours_of_operation = will_call_hours_of_operation
        if number is not None:
            self.number = number
        if home_page_url is not None:
            self.home_page_url = home_page_url
        if comments is not None:
            self.comments = comments
        if additional_comments is not None:
            self.additional_comments = self._define_object(
                additional_comments, DropLocationAdditionalComments
            )
        if disclaimer is not None:
            self.disclaimer = disclaimer
        if slic is not None:
            self.slic = slic
        self.timezone = timezone
        if facility_type is not None:
            self.facility_type = facility_type
        if operating_hours is not None:
            self.operating_hours = self._define_object(
                operating_hours, DropLocationOperatingHours
            )
        if localized_instruction is not None:
            self.localized_instruction = self._define_list(
                localized_instruction, DropLocationLocalizedInstruction
            )
        if promotion_information is not None:
            self.promotion_information = self._define_list(
                promotion_information, DropLocationPromotionInformation
            )
        if sort_code is not None:
            self.sort_code = self._define_object(sort_code, DropLocationSortCode)
        if service_offering_list is not None:
            self.service_offering_list = self._define_object(
                service_offering_list, DropLocationServiceOfferingList
            )
        if display_phone_number_indicator is not None:
            self.display_phone_number_indicator = display_phone_number_indicator
        if access_point_information is not None:
            self.access_point_information = self._define_object(
                access_point_information, DropLocationAccessPointInformation
            )
        if location_image is not None:
            self.location_image = self._define_object(
                location_image, DropLocationLocationImage
            )
        if location_new_indicator is not None:
            self.location_new_indicator = location_new_indicator
        if promotional_link_url is not None:
            self.promotional_link_url = promotional_link_url
        if featured_rank is not None:
            self.featured_rank = featured_rank
        if will_call_location_indicator is not None:
            self.will_call_location_indicator = will_call_location_indicator
